GNU Radio C++ API Reference: gr::prefs Class Reference

| GNU Radio C++ API Reference 3.10.12.0 The Free & Open Software Radio Ecosystem |

Loading...
Searching...
No Matches
gr::prefs Class Reference
Miscellaneous

Base class for representing user preferences a la windows INI files. More...

`#include <gnuradio/prefs.h>`

## Public Member Functions
| prefs ()
| Creates an object to read preference files.
void | add_config_file (const std::string &configfile)
std::string | to_string ()
| Returns the configuration options as a string.
void | save ()
| Saves the configuration settings to ${HOME}/.gnuradio/config.conf.
bool | has_section (const std::string &section)
| Does `section` exist?
bool | has_option (const std::string &section, const std::string &option)
| Does `option` exist?
const std::string | get_string (const std::string &section, const std::string &option, const std::string &default_val)
| If option exists return associated value; else default_val.
void | set_string (const std::string &section, const std::string &option, const std::string &val)
| Set or add a string `option` to `section` with value `val`.
bool | get_bool (const std::string &section, const std::string &option, bool default_val)
| If option exists and value can be converted to bool, return it; else default_val.
void | set_bool (const std::string &section, const std::string &option, bool val)
| Set or add a bool `option` to `section` with value `val`.
long | get_long (const std::string &section, const std::string &option, long default_val)
| If option exists and value can be converted to long, return it; else default_val.
void | set_long (const std::string &section, const std::string &option, long val)
| Set or add a long `option` to `section` with value `val`.
double | get_double (const std::string &section, const std::string &option, double default_val)
| If option exists and value can be converted to double, return it; else default_val.
void | set_double (const std::string &section, const std::string &option, double val)
| Set or add a double `option` to `section` with value `val`.

## Static Public Member Functions
static prefs * | singleton ()

## Protected Member Functions
std::vector< std::string > | _sys_prefs_filenames ()
void | _read_files (const std::vector< std::string > &filenames)
char * | option_to_env (std::string section, std::string option)
template<typename T>
T | get_general (const std::string &section, const std::string &option, const T &default_val)
template<typename T>
void | set_general (const std::string &section, const std::string &option, const T &val)

## Detailed Description

Base class for representing user preferences a la windows INI files.

The real implementation is in Python, and is accessible from C++ via the magic of SWIG directors.

## Constructor & Destructor Documentation

## ◆ prefs()

gr::prefs::prefs | ( |  | ) |

Creates an object to read preference files.

If no file name is given (empty arg list or ""), this opens up the standard GNU Radio configuration files in prefix/etc/gnuradio/conf.d as well as ~/.gnuradio/config.conf.

Only access this through the singleton defined here:

prefs *p = prefs::singleton();
gr::prefs::prefs
prefs()
Creates an object to read preference files.
gr::prefs::singleton
static prefs * singleton()

Referenced by singleton().

## Member Function Documentation

## ◆ _read_files()

void gr::prefs::_read_files | ( | const std::vector< std::string > & | filenames | ) |
| protected

## ◆ _sys_prefs_filenames()

std::vector< std::string > gr::prefs::_sys_prefs_filenames | ( |  | ) |
| protected

## ◆ add_config_file()

void gr::prefs::add_config_file | ( | const std::string & | configfile | ) |

If specifying a file name, this opens that specific configuration file of the standard form containing sections and key-value pairs:

[SectionName]
key0 = value0
key1 = value1

Referenced by thrift_server_template< TserverBase, TserverClass, TImplClass >::thrift_server_template().

## ◆ get_bool()

bool gr::prefs::get_bool | ( | const std::string & | section,
|  | const std::string & | option,
|  | bool | default_val )

If option exists and value can be converted to bool, return it; else default_val.

## ◆ get_double()

double gr::prefs::get_double | ( | const std::string & | section,
|  | const std::string & | option,
|  | double | default_val )

If option exists and value can be converted to double, return it; else default_val.

## ◆ get_general()

template<typename T>

T gr::prefs::get_general | ( | const std::string & | section,
|  | const std::string & | option,
|  | const T & | default_val )
| protected

## ◆ get_long()

long gr::prefs::get_long | ( | const std::string & | section,
|  | const std::string & | option,
|  | long | default_val )

If option exists and value can be converted to long, return it; else default_val.

Referenced by thrift_server_template< TserverBase, TserverClass, TImplClass >::thrift_server_template().

## ◆ get_string()

const std::string gr::prefs::get_string | ( | const std::string & | section,
|  | const std::string & | option,
|  | const std::string & | default_val )

If option exists return associated value; else default_val.

Referenced by thrift_server_template< TserverBase, TserverClass, TImplClass >::thrift_server_template().

## ◆ has_option()

bool gr::prefs::has_option | ( | const std::string & | section,
|  | const std::string & | option )

Does `option` exist?

## ◆ has_section()

bool gr::prefs::has_section | ( | const std::string & | section | ) |

Does `section` exist?

## ◆ option_to_env()

char * gr::prefs::option_to_env | ( | std::string | section,
|  | std::string | option )
| protected

## ◆ save()

void gr::prefs::save | ( |  | ) |

Saves the configuration settings to ${HOME}/.gnuradio/config.conf.

WARNING: this will overwrite your current config.conf file.

## ◆ set_bool()

void gr::prefs::set_bool | ( | const std::string & | section,
|  | const std::string & | option,
|  | bool | val )

Set or add a bool `option` to `section` with value `val`.

## ◆ set_double()

void gr::prefs::set_double | ( | const std::string & | section,
|  | const std::string & | option,
|  | double | val )

Set or add a double `option` to `section` with value `val`.

## ◆ set_general()

template<typename T>

void gr::prefs::set_general | ( | const std::string & | section,
|  | const std::string & | option,
|  | const T & | val )
| protected

## ◆ set_long()

void gr::prefs::set_long | ( | const std::string & | section,
|  | const std::string & | option,
|  | long | val )

Set or add a long `option` to `section` with value `val`.

## ◆ set_string()

void gr::prefs::set_string | ( | const std::string & | section,
|  | const std::string & | option,
|  | const std::string & | val )

Set or add a string `option` to `section` with value `val`.

## ◆ singleton()

prefs * gr::prefs::singleton | ( |  | ) |
| static

References prefs().

Referenced by thrift_server_template< TserverBase, TserverClass, TImplClass >::thrift_server_template().

## ◆ to_string()

std::string gr::prefs::to_string | ( |  | ) |

Returns the configuration options as a string.

The documentation for this class was generated from the following file:

- prefs.h